module BloqadeODE

using Adapt
using Reexport
using SciMLBase
using DiffEqBase
using YaoArrayRegister
using YaoSubspaceArrayReg
@reexport using BloqadeExpr
@reexport using OrdinaryDiffEq
using BloqadeExpr: Hamiltonian
using LinearAlgebra

export SchrodingerProblem, SchrodingerEquation

include("problem.jl")

end

using Test

if "docstring" in ARGS
    # include("docstrings.jl")
    exit()
end

@testset "problem" begin
    include("problem.jl")
end

@testset "forward diff" begin
    include("forwarddiff.jl")
end

using Yao
using BloqadeODE
using BloqadeExpr
using BloqadeMIS
using BloqadeKrylov
using Test

@testset "ODE problem interface" begin
    reg = zero_state(5)
    tspan = (0, 1e-4)
    atoms = [(i,) for i in 1:5]
    h = rydberg_h(atoms; C = 2π * 109.16, Ω = sin, ϕ = cos)
    prob = SchrodingerProblem(reg, tspan, h; dt = 1e-5, progress = true, save_start = false)

    println()
    show(stdout, MIME"text/plain"(), prob)
    println()
    show(stdout, MIME"text/plain"(), prob.f.f)

    integrator = init(prob, Vern8())
    for (u, t) in tuples(integrator)
        @test u === prob.state
        @test vec(prob.reg.state) ≈ u
    end

    # integrator should be initialize properly
    integrator = init(prob, Vern8())
    @test integrator.u ≈ statevec(zero_state(5))
end

@testset "select specific time" begin
    reg = zero_state(5)
    tspan = (0, 0.2)
    atoms = [(i,) for i in 1:5]
    h = rydberg_h(atoms; C = 2π * 109.16, Ω = sin, ϕ = cos)
    prob = SchrodingerProblem(reg, tspan, h; dt = 1e-5, progress = true, save_start = false)
    integrator = init(prob, Vern8())
    for (u, t) in TimeChoiceIterator(integrator, [0.05, 0.1])
        @test t in [0.05, 0.1]
    end
end

@testset "ODE evolution results" begin
    atoms = [(i,) for i in 1:5]
    space = blockade_subspace(atoms, 1.5)

    @testset "h=$name" for (name, h) in [
        "x+z" => SumOfX(5, 1.0) + SumOfN(5, sin),
        "rydberg" => rydberg_h(atoms; Δ = sin, Ω = cos, C = 2π * 109),
    ]
        dt = 1e-5
        @testset "subspace" begin
            ref = zero_state(space)
            discrete = KrylovEvolution(ref, collect(0.0:dt:0.2), h)
            BloqadeExpr.emulate!(discrete)

            reg = zero_state(space)
            prob = SchrodingerProblem(reg, 0.2, h)
            BloqadeExpr.emulate!(prob)
            @test prob.reg ≈ ref atol = 1e-4
        end

        @testset "fullspace" begin
            ref = zero_state(5)
            BloqadeExpr.emulate!(KrylovEvolution(ref, collect(0.0:dt:0.2), h))

            reg = zero_state(5)
            BloqadeExpr.emulate!(SchrodingerProblem(reg, 0.2, h))
            @test ref ≈ reg atol = 1e-4
        end
    end
end

@testset "assertions" begin
    atoms = [(i,) for i in 1:5]
    @test_throws ArgumentError SchrodingerProblem(zero_state(10), 0.2, rydberg_h(atoms; Ω = 1.0))
end

@testset "3-level W-state ODE simulation" begin
    nsites = 2
    V = 1e5
    atoms = [(0.0, 0.0), (0.0, (862690*2pi/V)^(1/6))]
    reg = product_state(dit"11;3")
    h = rydberg_h_3(atoms; Ω_r = 1)

    goal = exp(-im*pi/sqrt(2)*Matrix(h)) * state(reg)
    prob = SchrodingerProblem(reg, (0, pi/sqrt(2)), h)
    emulate!(prob)
    @test isapprox(state(reg), goal; atol = 1e-3)
end

"""
    struct SchrodingerEquation

Type for Schrodinger equation. A `SchrodingerEquation`
object is a callable object that has method `f(dstate, state, p, t)`
that fits into a standard ODE problem.
"""
struct SchrodingerEquation{ExprType,H<:Hamiltonian}
    expr::ExprType
    hamiltonian::H
end

Adapt.@adapt_structure SchrodingerEquation

function (eq::SchrodingerEquation)(dstate, state, p, t::Number)
    fill!(dstate, zero(eltype(dstate)))
    for (f, term) in zip(eq.hamiltonian.fs, eq.hamiltonian.ts)
        mul!(dstate, term, state, -im * f(t), one(t))
    end
    return
end

function Base.show(io::IO, mime::MIME"text/plain", eq::SchrodingerEquation)
    indent = get(io, :indent, 0)
    tab(indent) = " "^indent
    print(io, tab(indent), "storage size: ")
    printstyled(io, Base.format_bytes(storage_size(eq.hamiltonian)); color = :yellow)
    println(io)
    println(io, tab(indent), "expression:")
    show(IOContext(io, :indent => indent + 2), eq.expr)
    println(io)
    return println(io)
end

"""
    struct SchrodingerProblem
    SchrodingerProblem(reg, tspan, hamiltonian; kw...)

Define a Schrodinger equation problem that uses ODE solver from `OrdinaryDiffEq`
to solve the dynamics.

# Arguments

- `register`: required, the evolution problem register, can be a [`SubspaceArrayReg`](@ref) or an `ArrayReg`
    from `Yao`.
- `tspan`: required, a `(start, stop)` tuple or a single number `t`, the single value form `t` is equivalent
    to `(zero(t), t)`.
- `hamiltonian`: required, the evolution hamiltonian, can be created via [`rydberg_h`](@ref).

# Common Keyword Arguments

- `algo`: optional, algorithm to use, this only works for the `emulate!` interface.
    for `solve` or integrator interface, one will need to specify the algorithm explicitly.
- `progress`: print progress bar or not, this may effect the performance when problem scale is small, default is `true`.
- `progress_steps`: steps to update the progress bar, default is `5`.
- `reltol`: relative tolerance, default is 1e-8.
- `abstol`: absolute tolerance, default is 1e-8.

# Further References

For more ODE options, please refer to [Common Solver Options](https://diffeq.sciml.ai/stable/basics/common_solver_opts/).
The `SchrodingerProblem` type supports most of the standard DiffEq problem interface.
"""
struct SchrodingerProblem{Reg,EquationType<:ODEFunction,uType,tType,Algo,Kwargs} <:
       SciMLBase.AbstractODEProblem{uType,tType,true}
    reg::Reg
    f::EquationType
    state::uType # alias of reg.state
    u0::uType # a copy of input state
    tspan::tType
    algo::Algo

    # constant solver parameters
    kwargs::Kwargs

    p::Nothing # well make DiffEq happy
end

function SchrodingerProblem(reg::AbstractRegister, tspan, expr; algo=DP8(), kw...)
    nqudits(reg) == nqudits(expr) || throw(ArgumentError("number of qubits/sites does not match!"))
    # remove this after ArrayReg start using AbstractVector
    state = statevec(reg)
    space = YaoSubspaceArrayReg.space(reg)
    tspan = SciMLBase.promote_tspan(tspan)
    # create term cache
    # always follow register element-type
    T = real(eltype(state))
    T = isreal(expr) ? T : Complex{T}
    eq = SchrodingerEquation(expr, Hamiltonian(T, expr, space))
    ode_f = ODEFunction(eq)

    tspan_type = promote_type(real(eltype(state)), eltype(tspan))
    tspan = tspan_type.(tspan) # promote tspan to T so Dual number works

    default_ode_options = (
        save_everystep = false,
        save_start = false,
        save_on = false,
        dense = false,
        reltol=1e-10,
        abstol=1e-10,
        alias_u0 = true,
    )
    kw = pairs(merge(default_ode_options, kw))

    return SchrodingerProblem{typeof(reg),typeof(ode_f),typeof(state),typeof(tspan),typeof(algo), typeof(kw)}(
        reg,
        ode_f,
        state,
        state,
        tspan,
        algo,
        kw,
        nothing,
    )
end

function Adapt.adapt_structure(to, x::SchrodingerProblem)
    d_reg = adapt(to, x.reg)
    state = statevec(d_reg)
    return SchrodingerProblem(
        d_reg, adapt(to, x.f), state,
        copy(state), x.tspan, x.algo, x.kwargs, x.p
    )
end

# multi-line printing
function Base.show(io::IO, mime::MIME"text/plain", prob::SchrodingerProblem)
    indent = get(io, :indent, 0)
    tab(indent) = " "^indent

    println(io, tab(indent), "SchrodingerProblem:")
    # state info
    println(io, tab(indent + 2), "register info:")
    print(io, tab(indent + 4), "type: ")
    printstyled(io, typeof(prob.reg); color = :green)
    println(io)

    print(io, tab(indent + 4), "storage size: ")
    printstyled(io, Base.format_bytes(storage_size(prob.reg)); color = :yellow)
    println(io)
    println(io)

    # tspan info
    println(io, tab(indent + 2), "time span (μs): ", prob.tspan)
    println(io)

    # equation info
    println(io, tab(indent + 2), "equation: ")
    show(IOContext(io, :indent => indent + 4), mime, prob.f.f)
    println(io, tab(indent + 4), "algorithm: ", repr(prob.algo))

    # options
    isempty(prob.kwargs) || println(io, tab(indent + 2), "options:")
    order = [:dt, :adaptive, :progress]
    for key in order
        if haskey(prob.kwargs, key)
            println(io, tab(indent + 4), key, ": ", repr(prob.kwargs[key]))
        end
    end

    for (key, value) in prob.kwargs
        key in order || println(io, tab(indent + 4), key, ": ", repr(value))
    end
    # println(io)
end

function DiffEqBase.solve(prob::SchrodingerProblem, args...; sensealg = nothing, initial_state = nothing, kw...)
    if sensealg === nothing && haskey(prob.kwargs, :sensealg)
        sensealg = prob.kwargs[:sensealg]
    end

    # update initial state
    if initial_state !== nothing
        initial_state isa AbstractRegister ||
            throw(ArgumentError("initial_state must be a register, got $(typeof(initial_state))"))
        u0 = statevec(initial_state)
    else
        u0 = prob.u0
    end
    return DiffEqBase.solve_up(prob, sensealg, u0, nothing, args...; kw...)
end

DiffEqBase.get_concrete_problem(prob::SchrodingerProblem, isadapt; kw...) = prob

function BloqadeExpr.emulate!(prob::SchrodingerProblem)
    solve(prob, prob.algo)
    return prob
end

using Test
using Random
using ForwardDiff
using BloqadeODE
using YaoSubspaceArrayReg
using FiniteDifferences
using YaoArrayRegister
using BloqadeMIS
using BloqadeWaveforms

function loss(xs::Vector)
    reg = zero_state(Complex{eltype(xs)}, 5)
    tspan = (0, 0.1)
    atoms = [(i,) for i in 1:5]
    Ω = piecewise_constant(clocks = [0.0, 0.1, 0.2, 0.3, 0.4, 0.5], values = xs)
    h = rydberg_h(atoms; C = 2π * 109.16, Ω, ϕ = 0.1)
    prob = SchrodingerProblem(reg, tspan, h; dt = 1e-3)
    emulate!(prob)
    return fidelity(reg, product_state(bit"00001"))
end

Random.seed!(42)
xs = rand(5)

Δ_ad = ForwardDiff.gradient(loss, xs)
Δ_fd, = FiniteDifferences.grad(central_fdm(5, 1), loss, xs)

@test Δ_ad ≈ Δ_fd rtol = 1e-2
